﻿
init python:
    import random
    import time
    random.seed(time.clock())
    class snake_class:
        def __init__(self):
            self.speed = 1
            self.snake = [(5,5), (5,4), (5,3)]
            self.apples = []
            self.max_apples = 1
            self.points = 0
            self.shedded = 0
            self.shedded_raise = 0
            self.mode = "Classic"
            self.direction = "s"
            self.axis = "y"
            self.alive = True
            self.locked = False
        def shed(self):
            length = len(self.snake)
            if length > 6:
                renpy.play("snake/shed.ogg", "sfx2")
                self.snake = self.snake[:3]
                self.shedded = length-3
                Show("snake_points", g=self)()
                if self.speed < 35:
                    self.speed += 1
        def points_get(self):
            if self.shedded > 0:
                self.shedded_raise += 1
                self.points += self.shedded_raise
                self.shedded -= 1
                self.shedded_raise
                renpy.play("snake/coin.ogg", "sfx2")
            else:
                renpy.play("snake/cash_register.ogg", "sfx2")
                Hide("snake_points")()
                self.shedded_raise = 0
        def reset(self):
            self.speed = 1
            self.snake = [(5,5), (5,4), (5,3)]
            self.apples = []
            self.direction = "s"
            self.axis = "y"
            self.alive = True
            self.locked = False
            self.points = 0
            self.shedded = 0
            self.shedded_raise = 0
        def spawn(self):
            apple = (random.randint(0,24), random.randint(0,23))
            if len(self.apples) < self.max_apples:
                if not apple in self.snake:
                    if not apple in self.apples:
                        renpy.play("snake/port.ogg", "sfx1")
                        self.apples.append(apple)
        def change_direction(self, direction, axis):
            if not axis == self.axis and not self.locked:
                self.axis = axis
                self.direction = direction
                self.locked = True
                renpy.play("snake/turn.ogg", "sound")
        def change_mode(self, mode):
            if mode == "Classic":
                self.max_apples = 1
            elif mode == "Multi":
                self.max_apples += 1
            elif mode == "Mayhem":
                self.max_apples = 100
            self.mode = mode
        def tick(self):
            if self.direction == "w":
                head = (self.snake[0][0], self.snake[0][1]-1)
            elif self.direction == "s":
                head = (self.snake[0][0], self.snake[0][1]+1)
            elif self.direction == "a":
                head = (self.snake[0][0]-1, self.snake[0][1])
            elif self.direction == "d":
                head = (self.snake[0][0]+1, self.snake[0][1])
            self.snake.insert(0, head)
            self.locked = False
            if head in self.apples:
                self.apples.remove(head)
                renpy.play("snake/apple.ogg", "sound")
            else:
                self.snake.pop(-1)
            if head[0] < 0 or head[1] < 0 or head[0] > 24 or head[1] > 24 or head in self.snake[1:]:
                self.alive = False
                renpy.play("snake/death.ogg", "sound")



default snake_handler = snake_class()
screen snake(g = snake_handler):
    modal True
    style_prefix "snake"
    if g.alive:
        timer (40-g.speed)*.01 repeat True action Function(g.tick)
        timer 2 repeat True action Function(g.spawn)
    frame xysize 100,100 align .0,1.0 offset 140,-140 padding 0,0 background None:
        for i in zip(["w", "s", "a", "d"], ["y", "y", "x", "x"]):
            key i[0] action Function(g.change_direction, i[0], i[1])
            button xysize 100,100:
                text i[0] align .5,.5
                action Function(g.change_direction, i[0], i[1])
                if i[0] == "w":
                    yoffset -100
                elif i[0] == "s":
                    yoffset 100
                elif i[0] == "a":
                    xoffset -100
                elif i[0] == "d":
                    xoffset 100
    hbox align 1.0,1.0 offset -140,-140 spacing 16:
        if not g.alive:
            button xysize 100,100:
                text "Reset" align .5,.5
                action Function(g.reset)

        button xysize 100,100:
            text "Shed" align .5,.5
            action Function(g.shed), SelectedIf(len(g.snake) > 6) keysym "K_SPACE"


    frame xysize 500,500 background "#444" align .5,.5 padding 0,0:
        vbox align .0,1.0 anchor 1.0,1.0 xoffset -8 spacing 8:
            for i in ["Classic", "Multi", "Mayhem"]:
                button xalign 1.0:
                    text i
                    action Function(g.change_mode, i), SelectedIf(g.mode == i)
        vbox align 1.0,1.0 anchor .0,1.0 xoffset 8 spacing 8:
            button xalign .0:
                text "Length: {}".format(len(g.snake))
            button xalign .0:
                text "Speed: {}".format(g.speed)
            button xalign .0:
                text "Apples: {} / {}".format(len(g.apples), g.max_apples)
        button align .5,1.0 anchor .5,.0 yoffset 8:
            text "Points: {}".format(g.points)

        for n,i in enumerate(g.snake):
            frame:
                xysize 20,20 margin 1,1
                offset i[0]*20,i[1]*20
                if n == 0:
                    background "#0f0"
                else:
                    background "#fff"
        for i in g.apples:
            frame:
                xysize 20,20 margin 1,1
                offset i[0]*20,i[1]*20
                background "#f00"


style snake_button:
    background "#fff9"
    selected_background "#ff09"
    padding (10,10)

screen snake_points(g):
    timer .4 repeat True action Function(g.points_get)
    if g.shedded_raise:
        text "+{}".format(g.shedded_raise) align .5,.87
    hbox align .5,.9 spacing 0:
        for i in range(g.shedded):
            frame:
                xysize 20,20 margin 1,1 background "#fff"


label snake_example:
    call screen snake

